/*
 * Corsa.java
 *
 * Created on 19 novembre 2005, 1.11
 */

/**
 * La classe Corsa rappresenta una corsa generata dal sistema
 * @author Daniele Baracchi
 */
public class Corsa {
    
    public final int autista;
    public final int linea;
    public final Orario partenza;
    public final Orario arrivo;
    
    /** Crea una nuova istanza di Corsa con i dati specificati */
    public Corsa(int autista, int linea, Orario partenza, int fermate) {
        this.autista = autista;
        this.linea = linea;
        this.partenza = partenza;
        // Genera automaticamente l'orario di arrivo
        this.arrivo = partenza.add(5*(fermate-1));
    }
    
    // Metodo utile principalmente per il debug
    public String toString() {
        return "(Aut: " + autista + " Lin: " + linea + " Par: " + partenza +
                " Arr: " + arrivo + ")";
    }
}
