//---------------------------------------------------------------------------
#include <vcl.h>
#include <stdlib.h>
#pragma hdrstop

#include "dmTimers.h"
#include "garaMain.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
int statoSemaforo;  // stato del semaforo
bool tram1, tram2;  // presenza dei tram
TdmTim *dmTim;
//---------------------------------------------------------------------------
__fastcall TdmTim::TdmTim(TComponent* Owner)
    : TDataModule(Owner)
{
    statoSemaforo=1;         // inizializzazione: verde per Nord-Sud, rosso per Est-Ovest
    tram1=false;             // nessun tram
    tram2=false;
    randomize();
}
//---------------------------------------------------------------------------
// auto1 orizzontale
void __fastcall TdmTim::TimerAutoH1Timer(TObject *Sender)
{
    // se l'auto ha il rosso o il giallo ed  alla striscia del semaforo
    if ((statoSemaforo==1 || statoSemaforo==2 || statoSemaforo==4)&&FormPrinc->autoH1->Left==200)
        TimerAutoH1->Enabled=false; // stop auto
    // se invece  dentro lo schema
    else if (FormPrinc->autoH1->Left<650)
        FormPrinc->autoH1->Left+=5; // avanza di 5 punti a destra
    // altrimenti
    else
    {
        TimerAutoH1->Enabled=false; // stop auto
        FormPrinc->autoH1->Visible=false;   // nascondi auto
        FormPrinc->autoH1->Left=0;  // reset posizione auto
    }
}
//---------------------------------------------------------------------------
// gestisce lo stato dei semafori
void __fastcall TdmTim::TimerSemaforoTimer(TObject *Sender)
{
    // se arriva un tram e il semaforo  gi verde o giallo per la dir. nord-sud
    if ((tram1 || tram2) && (statoSemaforo==1 || statoSemaforo==2))
        return; // nessuna operazione

    // passaggio stato successivo
    statoSemaforo++;
    if (statoSemaforo>4)  // ciclico
        statoSemaforo=1;

    switch (statoSemaforo)
    {
        case 1: // rosso orizzontale - verde verticale
            TimerSemaforo->Interval=TempoVerde; // set tempo durata Verde

            FormPrinc->rH1->Brush->Color=clRed; // disegno semafori
            FormPrinc->gH1->Brush->Color=clGray;
            FormPrinc->vH1->Brush->Color=clGray;

            FormPrinc->rH2->Brush->Color=clRed;
            FormPrinc->gH2->Brush->Color=clGray;
            FormPrinc->vH2->Brush->Color=clGray;

            FormPrinc->rV1->Brush->Color=clGray;
            FormPrinc->gV1->Brush->Color=clGray;
            FormPrinc->vV1->Brush->Color=clLime;

            FormPrinc->rV2->Brush->Color=clGray;
            FormPrinc->gV2->Brush->Color=clGray;
            FormPrinc->vV2->Brush->Color=clLime;

            // se le auto sono dentro lo schema e ferme, avvia i timer
            if (FormPrinc->autoV1->Top>0 && !TimerAutoV1->Enabled)
                TimerAutoV1->Enabled=true;
            if (FormPrinc->autoV3->Top>0 && !TimerAutoV3->Enabled)
                TimerAutoV3->Enabled=true;
            if (FormPrinc->autoV2->Top<448 && !TimerAutoV2->Enabled)
                TimerAutoV2->Enabled=true;
            if (FormPrinc->autoV4->Top<448 && !TimerAutoV4->Enabled)
                TimerAutoV4->Enabled=true;
            break;
        case 2: // rosso orizzontale - giallo verticale
            TimerSemaforo->Interval=TempoGiallo;  // set tempo durata Giallo

            FormPrinc->rH1->Brush->Color=clRed;
            FormPrinc->gH1->Brush->Color=clGray;
            FormPrinc->vH1->Brush->Color=clGray;

            FormPrinc->rH2->Brush->Color=clRed;
            FormPrinc->gH2->Brush->Color=clGray;
            FormPrinc->vH2->Brush->Color=clGray;

            FormPrinc->rV1->Brush->Color=clGray;
            FormPrinc->gV1->Brush->Color=clYellow;
            FormPrinc->vV1->Brush->Color=clGray;

            FormPrinc->rV2->Brush->Color=clGray;
            FormPrinc->gV2->Brush->Color=clYellow;
            FormPrinc->vV2->Brush->Color=clGray;
            break;
        case 3: // verde orizzontale - rosso verticale
            TimerSemaforo->Interval=TempoVerde;  // set tempo durata Verde

            FormPrinc->rH1->Brush->Color=clGray;
            FormPrinc->gH1->Brush->Color=clGray;
            FormPrinc->vH1->Brush->Color=clLime;

            FormPrinc->rH2->Brush->Color=clGray;
            FormPrinc->gH2->Brush->Color=clGray;
            FormPrinc->vH2->Brush->Color=clLime;

            FormPrinc->rV1->Brush->Color=clRed;
            FormPrinc->gV1->Brush->Color=clGray;
            FormPrinc->vV1->Brush->Color=clGray;

            FormPrinc->rV2->Brush->Color=clRed;
            FormPrinc->gV2->Brush->Color=clGray;
            FormPrinc->vV2->Brush->Color=clGray;

            // se le auto sono dentro lo schema e ferme, avvia i timer
            if (FormPrinc->autoH1->Left>0 && !TimerAutoH1->Enabled)
                TimerAutoH1->Enabled=true;
            if (FormPrinc->autoH3->Left>0 && !TimerAutoH3->Enabled)
                TimerAutoH3->Enabled=true;
            if (FormPrinc->autoH2->Left<664 && !TimerAutoH2->Enabled)
                TimerAutoH2->Enabled=true;
            if (FormPrinc->autoH4->Left<664 && !TimerAutoH4->Enabled)
                TimerAutoH4->Enabled=true;
            break;
        case 4: // giallo orizzontale - rosso verticale
            TimerSemaforo->Interval=TempoGiallo;    // set tempo durata Giallo

            FormPrinc->rH1->Brush->Color=clGray;
            FormPrinc->gH1->Brush->Color=clYellow;
            FormPrinc->vH1->Brush->Color=clGray;

            FormPrinc->rH2->Brush->Color=clGray;
            FormPrinc->gH2->Brush->Color=clYellow;
            FormPrinc->vH2->Brush->Color=clGray;

            FormPrinc->rV1->Brush->Color=clRed;
            FormPrinc->gV1->Brush->Color=clGray;
            FormPrinc->vV1->Brush->Color=clGray;

            FormPrinc->rV2->Brush->Color=clRed;
            FormPrinc->gV2->Brush->Color=clGray;
            FormPrinc->vV2->Brush->Color=clGray;
            break;
    }

}
//---------------------------------------------------------------------------
void __fastcall TdmTim::TimerAutoH2Timer(TObject *Sender)
{
    if ((statoSemaforo==1 || statoSemaforo==2 || statoSemaforo==4)&&FormPrinc->autoH2->Left==444)
        TimerAutoH2->Enabled=false;
    else if (FormPrinc->autoH2->Left>50)
        FormPrinc->autoH2->Left-=5;
    else
    {
        TimerAutoH2->Enabled=false;
        FormPrinc->autoH2->Visible=false;
        FormPrinc->autoH2->Left=664;
    }
}
//---------------------------------------------------------------------------
void __fastcall TdmTim::TimerAutoV1Timer(TObject *Sender)
{
    if ((statoSemaforo==3 || statoSemaforo==4 || statoSemaforo==2)&&FormPrinc->autoV1->Top==120)
        TimerAutoV1->Enabled=false;
    else if (FormPrinc->autoV1->Top<420)
        FormPrinc->autoV1->Top+=4;
    else
    {
        TimerAutoV1->Enabled=false;
        FormPrinc->autoV1->Visible=false;
        FormPrinc->autoV1->Top=0;
    }
}
//---------------------------------------------------------------------------
void __fastcall TdmTim::TimerAutoV2Timer(TObject *Sender)
{
    if ((statoSemaforo==3 || statoSemaforo==4 || statoSemaforo==2)&&FormPrinc->autoV2->Top==308)
        TimerAutoV2->Enabled=false;
    else if (FormPrinc->autoV2->Top>20)
        FormPrinc->autoV2->Top-=5;
    else
    {
        TimerAutoV2->Enabled=false;
        FormPrinc->autoV2->Visible=false;
        FormPrinc->autoV2->Top=448;
    }
}
//---------------------------------------------------------------------------
// determina l'arrivo di auto nei pressi dell'incrocio
void __fastcall TdmTim::TimerAutoTimer(TObject *Sender)
{
    switch (random(30)) // numeri da 0 a 29
    {
        case 1:     // arrivo auto1 orizzontale
        case 11:
            if (TimerAutoH1->Enabled)   // se gi presente
                break;
            TimerAutoH1->Enabled=true;  // avvio auto
            FormPrinc->autoH1->Visible=true;    // show auto
            break;

        case 2:     // arrivo auto2 orizzontale
        case 12:
            if (TimerAutoH2->Enabled)
                break;
            TimerAutoH2->Enabled=true;
            FormPrinc->autoH2->Visible=true;
            break;

        case 13:    // arrivo auto1 verticale
        case 3:
            if (TimerAutoV1->Enabled)
                break;
            TimerAutoV1->Enabled=true;
            FormPrinc->autoV1->Visible=true;
            break;

        case 4:    // arrivo auto2 verticale
        case 14:
            if (TimerAutoV2->Enabled)
                break;
            TimerAutoV2->Enabled=true;
            FormPrinc->autoV2->Visible=true;
            break;

        case 5:    // arrivo auto3 orizz
        case 15:
            if (TimerAutoH3->Enabled)
                break;
            TimerAutoH3->Enabled=true;
            FormPrinc->autoH3->Visible=true;
            break;

        case 6:    // arrivo auto4 orizz
        case 16:
            if (TimerAutoH4->Enabled)
                break;
            TimerAutoH4->Enabled=true;
            FormPrinc->autoH4->Visible=true;
            break;

        case 7:    // arrivo auto3 verticale
        case 17:
            if (TimerAutoV3->Enabled)
                break;
            TimerAutoV3->Enabled=true;
            FormPrinc->autoV3->Visible=true;
            break;

        case 8:    // arrivo auto4 verticale
        case 18:
            if (TimerAutoV4->Enabled)
                break;
            TimerAutoV4->Enabled=true;
            FormPrinc->autoV4->Visible=true;
            break;

        case 9:     // arrivo tram1 (da sud)
            if (tram1)  // se gi presente
                break;
            tram1=true;
            if (statoSemaforo==3)   // se Est-Ovest ha il verde
                TimerSemaforoTimer(0);  // cambio stato al semaforo

            FormPrinc->Tram1->Visible=true; // show tram1
            TimerTram1->Enabled=true;       // avvio tram1
            break;

        case 0:     // arrivo tram2 (nord)
            if (tram2)
                break;
            tram2=true;
            if (statoSemaforo==3)
                TimerSemaforoTimer(0);

            FormPrinc->Tram2->Visible=true;
            TimerTram2->Enabled=true;
            break;
    }
}
//---------------------------------------------------------------------------
void __fastcall TdmTim::TimerAutoH3Timer(TObject *Sender)
{
    if ((statoSemaforo==1 || statoSemaforo==2 || statoSemaforo==4)&&FormPrinc->autoH3->Left==200)
        TimerAutoH3->Enabled=false;
    else if (FormPrinc->autoH3->Left<650)
        FormPrinc->autoH3->Left+=4;
    else
    {
        TimerAutoH3->Enabled=false;
        FormPrinc->autoH3->Visible=false;
        FormPrinc->autoH3->Left=0;
    }
}
//---------------------------------------------------------------------------

void __fastcall TdmTim::TimerAutoH4Timer(TObject *Sender)
{
    if ((statoSemaforo==1 || statoSemaforo==2 || statoSemaforo==4)&&FormPrinc->autoH4->Left==444)
        TimerAutoH4->Enabled=false;
    else if (FormPrinc->autoH4->Left>50)
        FormPrinc->autoH4->Left-=4;
    else
    {
        TimerAutoH4->Enabled=false;
        FormPrinc->autoH4->Visible=false;
        FormPrinc->autoH4->Left=664;
    }
}
//---------------------------------------------------------------------------
void __fastcall TdmTim::TimerAutoV3Timer(TObject *Sender)
{
    if ((statoSemaforo==3 || statoSemaforo==4 || statoSemaforo==2)&&FormPrinc->autoV3->Top==120)
        TimerAutoV3->Enabled=false;
    else if (FormPrinc->autoV3->Top<420)
        FormPrinc->autoV3->Top+=6;
    else
    {
        TimerAutoV3->Enabled=false;
        FormPrinc->autoV3->Visible=false;
        FormPrinc->autoV3->Top=0;
    }
}
//---------------------------------------------------------------------------
void __fastcall TdmTim::TimerAutoV4Timer(TObject *Sender)
{
    if ((statoSemaforo==3 || statoSemaforo==4 || statoSemaforo==2)&&FormPrinc->autoV4->Top==308)
        TimerAutoV4->Enabled=false;
    else if (FormPrinc->autoV4->Top>20)
        FormPrinc->autoV4->Top-=4;
    else
    {
        TimerAutoV4->Enabled=false;
        FormPrinc->autoV4->Visible=false;
        FormPrinc->autoV4->Top=448;
    }
}
//---------------------------------------------------------------------------
// gestisce il movimento del tram1 (da Sud)
void __fastcall TdmTim::TimerTram1Timer(TObject *Sender)
{
    if (FormPrinc->Tram1->Top>0)    // se dentro lo schema
        FormPrinc->Tram1->Top-=4;       // avanza verso l'alto
    else                            // altrimenti
    {
        TimerTram1->Enabled=false;      // stop tram1
        FormPrinc->Tram1->Visible=false;// hide tram1
        FormPrinc->Tram1->Top=464;      // riposizionamento in basso
        tram1=false;
    }
}
//---------------------------------------------------------------------------
// gestisce il movimento del tram2 (da Nord)
void __fastcall TdmTim::TimerTram2Timer(TObject *Sender)
{
    if (FormPrinc->Tram2->Top<440)
        FormPrinc->Tram2->Top+=4;
    else
    {
        TimerTram2->Enabled=false;
        FormPrinc->Tram2->Visible=false;
        FormPrinc->Tram2->Top=-40;
        tram2=false;
    }
}
//---------------------------------------------------------------------------

